<?php
/*
Plugin Name: DefiThis
Plugin URI: http://devoracles.com/wp-plug-defithis/785
Description: Brings Google's (but not only) word definition feature one step closer to your blog by enabling for your users to look up the definition of the words they highlighted. This plug is useful if you have visitors from all around the World and your blog is in English. This is a beta release and we'd like to hear your thoughts about the plugin. Thanks for using this plugin.
Version: 0.1
Author: Gary of Devoracles
Author URI: http://devoracles.com/
*/

// OK, let's start with some variables, cos why not

global $wpdb;
$defithis_version = "0.1";
$wpdb->dt_a = $wpdb->prefix.'defithis';

$options_page = get_option('siteurl') . '/wp-admin/admin.php?page=defithis/options.php';

/*
Installing DefiThis. 
Used with register activate hook.
Register hook is at the end of this file 
*/
function defithis_install(){
	global $wpdb;

	if(@is_file(ABSPATH.'/wp-admin/upgrade-functions.php')) {
		include_once(ABSPATH.'/wp-admin/upgrade-functions.php');
	} elseif(@is_file(ABSPATH.'/wp-admin/includes/upgrade.php')) {
		include_once(ABSPATH.'/wp-admin/includes/upgrade.php');
	} else {
		die('We have problem finding your \'/wp-admin/upgrade-functions.php\' and \'/wp-admin/includes/upgrade.php\'');
	}

	$charset_collate = '';
	if($wpdb->supports_collation()) {
		if(!empty($wpdb->charset)) {
			$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		}
		if(!empty($wpdb->collate)) {
			$charset_collate .= " COLLATE $wpdb->collate";
		}
	}
	$dt_version = "0.1";
	$wpdb->dt_a = $wpdb->prefix.'defithis';
	
	$create_table = array();
	$create_table['defithis_opt'] = "CREATE TABLE $wpdb->dt_a (".
									"id int(1) NOT NULL auto_increment,".
									"version varchar(3) character set utf8 NOT NULL default '$dt_version',".
									"svc varchar(4) character set utf8 NOT NULL default 'goog',".
									"ico varchar(5) character set utf8 NOT NULL default 'qmark',".
									"PRIMARY KEY (id)) $charset_collate;";
	maybe_create_table($wpdb->dt_a, $create_table['defithis_opt']);
	$sql_create_opt = "INSERT INTO $wpdb->dt_a (id, version, svc, ico) 
								VALUES ('',
										'$dt_version',
										'goog', 'qmark');";
	$results = $wpdb->query($sql_create_opt);
}

/*
UnInstalling DefiThis. 
Used with register deactivate hook.
Register hook is at the end of this file 
*/

function defithis_UN_install(){
	global $wpdb;
	$wpdb->dt_a = $wpdb->prefix.'defithis';
	$unsql = "DROP TABLE $wpdb->dt_a" ;
	$results = $wpdb->query($unsql);
}


/*
Pushes options page in settings
Hook at the EOF
*/
function defithis_options_page() {
	add_options_page('DefiThis Options', 'DefiThis', 10, 'defithis/options.php');
}
/*
Renders the Javascript block in the Head section of the HTML
Retrieves settings from the database
*/
function defithis_insert_js(){
	global $wpdb;
	$wpdb->dt_a = $wpdb->prefix.'defithis';
	$sql = mysql_query("SELECT * FROM $wpdb->dt_a");
	if(mysql_affected_rows() > 0){
		$q = mysql_fetch_array($sql);
	}
	if($q['ico'] == 'qmark'){$q['ico'] = 'http://static.devoracles.com/qmark.png';}
	if($q['ico'] == 'qmar1'){$q['ico'] = 'http://static.devoracles.com/qmark1.png';}
	if($q['svc'] == 'goog'){$q['svc'] = 'http://www.google.com/search?hl=en&btnG=Google+Search&aq=f&oq=&q=define%3A';}
	if($q['svc'] == 'answ'){$q['svc'] = 'http://www.answers.com/';}
	if($q['svc'] == 'dict'){$q['svc'] = 'http://dictionary.reference.com/browse/';}
	$style = get_option('siteurl') . '/wp-content/plugins/defithis/stt/dTw.css';
	$script = get_option('siteurl') . '/wp-content/plugins/defithis/stt/defithis.js';
?>
<link rel="stylesheet" type="text/css" href="<?php echo $style; ?>" media="all" />
<script type="text/javascript">
var icon = '<?php echo $q['ico'];?>';
var serv = '<?php echo $q['svc'];?>';
</script>
<script src="<?php echo $script;?>" type="text/javascript" ></script>
<?php
}

register_activation_hook(__FILE__,'defithis_install');
register_deactivation_hook( __FILE__, 'defithis_UN_install' );
add_action('admin_menu', 'defithis_options_page');
add_action('wp_head', 'defithis_insert_js');
//EOF
?>